const {prepend_num} = require("nv-string-basic");
const {_Node} = require("nv-data-tree-csp-node");


function _get_open_str(that,indent) {
    if(that.$is_fstch()) {
        s = that.indent_+"    ".repeat(that.$depth_)+"if(){"
    } else if(that.$is_midch()) {
        s = that.indent_+"    ".repeat(that.$depth_)+"} else if(){"
    } else {
        s = that.indent_+"    ".repeat(that.$depth_)+"} else {"    
    }
    let forest = that[that.constructor.SYM_DICT.get_forest];
    let sz = String(forest.max_size).length;
    let seq = prepend_num(that.$sdfs_index_,10,sz)
    s = "/* <"+ seq +"> */" + s
    return(s)
}

function _get_close_str(that,indent) {
    let forest = that[that.constructor.SYM_DICT.get_forest];
    let sz = String(forest.max_size).length;
    let seq = prepend_num(that.$sdfs_index_,10,sz);
    if(that.$is_lstch()) {
        let s = that.indent_+"    ".repeat(that.$depth_)+"}"
        return(" ".repeat(8+sz)+s)
    } else {
        return("")
    }
}


class Branch extends _Node {
    #indent =""
    ////
    get indent_()  {return(this.#indent)}
    set indent_(n=0) {this.#indent= "   ".repeat(n)}
    get open_str_() {return(_get_open_str(this,this.indent_))}
    get close_str_() {return(_get_close_str(this,this.indent_))}
    ////
}


module.exports = Branch
