const {add_repr} = require("nv-facutil-basic");

const Branch = require("./branch");

function _repr(that) {
   let sedfs = that.$sedfs_.slice(1);
   sedfs.pop();
   let ary = sedfs.map(
       r=>{
           if(r[1]==='open') {
               return(r[0].open_str_)
           } else {
               return(r[0].close_str_)
           }
       }
   )
   let s = "\n" + ary.join("\n\n")
   s = s.replace(/[\n]{2,}/g,"\n\n")
   return(s)
}

add_repr(Branch,_repr);


////

function build(rt,pos,num,c,a,b,r) {
    let nd = rt.$sdfs_[pos];
    if(c) {nd.$append_children(num)}
    if(a) {nd.$add_rsibs(num)}
    if(b) {nd.$add_lsibs(num)}
    if(r) {nd.$disconn()}
    return(rt)
}


module.exports = {
    Branch,
    build
}
